var cfg = require('../../cfg.json');
var fs = require('fs');
var http = require('http');
var https = require('https');
var mysql = require('mysql');
var bot = require('coffea')();
var uuid = require('uuid');
const path = require('path');

var sql;
var haDC = () => {
  sql = mysql.createConnection(cfg.mysql);
  sql.connect((err) => {
    if(err) setTimeout(haDC,2000);
  });
  sql.on('error', (err) => {
    if(err.code === 'PROTOCOL_CONNECTION_LOST') haDC();
  });
};
haDC();

cfg.server.forEach((e,i,a) => {
  bot.add({
    "name": e.name,
    "host": e.host,
    "port": e.port,
    "ssl": e.ssl,
    "ssl_allow_invalid": e.ssl_allow_invalid,
    "pass": e.pass,
    "nick": e.nick,
    "username": e.username,
    "realname": e.realname
  });
  console.log("Server "+e.name+" wurde geladen");
});

bot.on('motd', (e) => {
  console.log("motd von "+e.network+" erhalten");
  bot.write('MODE f0ck +B', e.network, (c)=>{}); // Botflag
});

bot.on('message', (e) => {
  var orig = e.message;
  if(orig.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi)) { // shitpostcatcher
    var tmp = orig.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi); // get links
    tmp.forEach((entry,i,a) => {
      var tmpdest = uuid.v1().split('-')[0];
      dl(entry, "./b/"+tmpdest, (cb) => { // download item
        if(cb.status === true) {
          var tmpuser = getUser(e.user.getNick(), e.network);
          sql.query("insert into `f0ck`.`items` (`src`,`dest`,`username`,`userchannel`,`usernetwork`,`stamp`,`active`) values (?,?,?,?,?,?,?)", [
            entry,
            "./b/"+tmpdest+"."+cb.infos.ext,
            tmpuser['nick'],
            e.channel.getName(),
            e.network,
            Math.floor(new Date() / 1000),
            0
          ]).on('result', (result) => {
            e.reply("https://f0ck.me/"+result.insertId+" - "+path.parse(entry).base+" ("+cb.infos.mime+", ~"+formatSize(cb.infos.size)+") from "+tmpuser['nick']+" ("+tmpuser['username']+"@"+tmpuser['hostname']+")");
          }).on('error', (msg) => {
            e.reply(msg);
          });
        }
        else
          if(cb.type == 1)
            e.reply(cb.msg);
      });
    });
  }
  else if(orig.match(/^\.user/)) { // (debug) get userinfos
    var tmp = getUser(e.user.getNick(), e.network);
    setTimeout(()=>{ e.reply(tmp); }, 1500);
  }
  else if(orig.match(/^\.del/) && e.channel.getName() == "#f0ck") {
    sql.query("truncate table `f0ck`.`items`")
      .on('end', () => {
        e.reply("database truncated");
      }).on('error', (msg) => {
        e.reply(msg);
      });
  }
});

var getUser = (u, n) => {
  bot.whois(u, n, (fn)=>{ }); // send whois
  var start = Date.now();
  while(Date.now() < start + 1000) {} // block script for catch whois
  return bot.getUser(u, n);
};

var dl = (url, dest, cb) => {
  var request = (url.match(/^https/)?https:http).get(url, (response) => { // type:1=post,type:2=stfu
    console.log(response.headers['content-type']);
    if(cfg.allowedMimes.hasOwnProperty(response.headers['content-type'])) {
      if(response.headers['content-length'] <= cfg.maxFileSize) {
        checkRepost(url, (cbcr) => {
          if(cbcr) {
            var file = fs.createWriteStream(dest+"."+cfg.allowedMimes[response.headers['content-type']]);
            response.pipe(file);
            file.on('finish', () => {
              file.close();
              cb({'status':true, 'msg':'downloaded '+dest, 'type':1, 'infos':{'mime':response.headers['content-type'], 'size':response.headers['content-length'], 'ext':cfg.allowedMimes[response.headers['content-type']]}});
            });
            file.on('error', (err) => {
              fs.unlink(dest);
              file.close();
              cb({'status':false, 'msg':err.message, 'type':1});
            });
          }
          else
            cb({'status':false, 'msg':'repost motherf0cker', 'type':1});
        });
      }
      else
        cb({'status':false, 'msg':'f0ck! your file is too big (~'+formatSize(response.headers['content-length'])+'), max '+formatSize(cfg.maxFileSize)+' allowed', 'type':1});
    }
    else
      cb({'status':false, 'msg':'f0ck you', 'type':2});
  }).on('error', (msg) => {
    cb({'status':false, 'msg':msg, 'type':2});
  });
};

var checkRepost = (url, cbcr) => {
  sql.query("select count(*) as count from `f0ck`.`items` where `src` = ?", url, (err, rows, fields) => {
    cbcr((rows[0].count == 0)?true:false);
  });
};

var formatSize = (size) => {
  var i = Math.floor(Math.log(size) / Math.log(1024));
  return (size / Math.pow(1024, i)).toFixed(2) * 1 + ' ' + ['B', 'kB', 'MB', 'GB', 'TB'][i];
};



// Webserver
var handleRequest = (request, response) => {
  var tmpres = "";
  if(request.url == "/") {
    sql.query("select * from `f0ck`.`items`", (err, rows, fields) => {
      rows.forEach((e,i,a) => {
        tmpres += e.src+"\n";
      });
    });
  }
  else {
    tmpres = "404";
  }
  setTimeout(()=>{response.end(tmpres);},1000);
};

var server = http.createServer(handleRequest);
server.listen(cfg.webserver.port, () => {
  console.log("Server listening on: http://localhost:%s", cfg.webserver.port);
});